(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@acoustic-content-sdk/rest-api'), require('@acoustic-content-sdk/utils'), require('rxjs'), require('rxjs/ajax'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@acoustic-content-sdk/redux-ajax', ['exports', '@acoustic-content-sdk/rest-api', '@acoustic-content-sdk/utils', 'rxjs', 'rxjs/ajax', 'rxjs/operators'], factory) :
    (global = global || self, factory((global['acoustic-content-sdk'] = global['acoustic-content-sdk'] || {}, global['acoustic-content-sdk']['redux-ajax'] = {}), global['acoustic-content-sdk']['rest-api'], global['acoustic-content-sdk'].utils, global.rxjs, global.rxjs.ajax, global.rxjs.operators));
}(this, (function (exports, restApi, utils, rxjs, ajax, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/auth.content.utils.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} aValue
     * @return {?}
     */
    function isBaseAuthoringItem(aValue) {
        return (utils.isNotNil(aValue) && utils.isString(aValue.id) && utils.isString(aValue.classification));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/fetch.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Uses [the Fetch API](https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API) to
     * make an HTTP request.
     *
     * **WARNING** Parts of the fetch API are still experimental. `AbortController` is
     * required for this implementation to work and use cancellation appropriately.
     *
     * Will automatically set up an internal [AbortController](https://developer.mozilla.org/en-US/docs/Web/API/AbortController)
     * in order to teardown the internal `fetch` when the subscription tears down.
     *
     * If a `signal` is provided via the `init` argument, it will behave like it usually does with
     * `fetch`. If the provided `signal` aborts, the error that `fetch` normally rejects with
     * in that scenario will be emitted as an error from the observable.
     *
     * ### Basic Use
     *
     * ```ts
     * import { of } from 'rxjs';
     * import { fromFetch } from 'rxjs/fetch';
     * import { switchMap, catchError } from 'rxjs/operators';
     *
     * const data$ = fromFetch('https://api.github.com/users?per_page=5').pipe(
     *  switchMap(response => {
     *    if (response.ok) {
     *      // OK return data
     *      return response.json();
     *    } else {
     *      // Server is returning a status requiring the client to try something else.
     *      return of({ error: true, message: `Error ${response.status}` });
     *    }
     *  }),
     *  catchError(err => {
     *    // Network or other error, handle appropriately
     *    console.error(err);
     *    return of({ error: true, message: err.message })
     *  })
     * );
     *
     * data$.subscribe({
     *  next: result => console.log(result),
     *  complete: () => console.log('done')
     * })
     * ```
     *
     * @param {?} input - The resource you would like to fetch. Can be a url or a request object.
     * @param {?=} init - A configuration object for the fetch.
     * [See MDN for more details](https://developer.mozilla.org/en-US/docs/Web/API/WindowOrWorkerGlobalScope/fetch#Parameters)
     * @return {?} An Observable, that when subscribed to performs an HTTP request using the native `fetch`
     * function. The {\@link Subscription} is tied to an `AbortController` for the the fetch.
     */
    function fromFetch(input, init) {
        return new rxjs.Observable((/**
         * @param {?} subscriber
         * @return {?}
         */
        function (subscriber) {
            /** @type {?} */
            var controller = new AbortController();
            /** @type {?} */
            var signal = controller.signal;
            /** @type {?} */
            var outerSignalHandler;
            /** @type {?} */
            var abortable = true;
            /** @type {?} */
            var unsubscribed = false;
            if (init) {
                // If a signal is provided, just have it teardown. It's a cancellation token, basically.
                if (init.signal) {
                    if (init.signal.aborted) {
                        controller.abort();
                    }
                    else {
                        outerSignalHandler = (/**
                         * @return {?}
                         */
                        function () {
                            if (!signal.aborted) {
                                controller.abort();
                            }
                        });
                        init.signal.addEventListener('abort', outerSignalHandler);
                    }
                }
                init = __assign(__assign({}, init), { signal: signal });
            }
            else {
                init = { signal: signal };
            }
            fetch(input, init)
                .then((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                abortable = false;
                subscriber.next(response);
                subscriber.complete();
            }))
                .catch((/**
             * @param {?} err
             * @return {?}
             */
            function (err) {
                abortable = false;
                if (!unsubscribed) {
                    // Only forward the error if it wasn't an abort.
                    subscriber.error(err);
                }
            }));
            return (/**
             * @return {?}
             */
            function () {
                unsubscribed = true;
                if (abortable) {
                    controller.abort();
                }
            });
        }));
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/fetch.text.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SLASH = '/';
    /** @type {?} */
    var PUBLISH_PRIORITY_HEADER_VALUE = 'now';
    /** @type {?} */
    var CONTENT_TYPE_HEADER_VALUE_JSON = 'application/json';
    /** @type {?} */
    var USE_CACHE = true;
    /** @type {?} */
    var FETCH_TEXT_LOGGER = 'FetchTextAjax';
    /*
     * Makes sure our path ends with a proper trailing slash
     */
    /**
     * @param {?} aUrl
     * @return {?}
     */
    function _ensureTrailingSlash(aUrl) {
        return aUrl.endsWith(SLASH) ? aUrl : aUrl + SLASH;
    }
    /*
     * Makes sure our path ends with a proper trailing slash
     */
    /**
     * @param {?} aUrl
     * @return {?}
     */
    function removeStartingSlash(aUrl) {
        return aUrl.indexOf(SLASH) === 0 ? aUrl.substr(1) : aUrl;
    }
    /**
     * Fetch text using the normal APIs
     *
     * @param {?} url  - URL used to fetch the text
     * @param {?} withCredentials  - credential flag
     *
     * @return {?} the text
     */
    function fetchTextNormal(url, withCredentials) {
        return utils.rxPipe(ajax.ajax({ url: url, withCredentials: withCredentials, responseType: 'text' }), utils.typedPluck('response'), 
        // make sure to decouple the result handling on a new thread
        operators.observeOn(rxjs.asyncScheduler));
    }
    /**
     * Fetch text with lower priority
     *
     * @param {?} url  - URL used to fetch the text
     * @param {?} withCredentials  - credential flag
     *
     * @return {?} the text
     */
    function fetchTextLow(url, withCredentials) {
        // config
        /** @type {?} */
        var init = { importance: 'low' };
        // credentials
        if (withCredentials) {
            init.credentials = 'include';
        }
        // fetch
        return utils.rxPipe(fromFetch(url, init), operators.switchMap((/**
         * @param {?} resp
         * @return {?}
         */
        function (resp) { return resp.text(); })), 
        // subscribe on the idle frame
        operators.subscribeOn(utils.idleFrameScheduler), 
        // make sure to decouple the result handling on a new thread
        operators.observeOn(rxjs.asyncScheduler));
    }
    /**
     * Creates a callback function that loads content via HTTP GET from the API routes.
     *
     * @param {?} apiBase - the {\@link https://developer.ibm.com/customer-engagement/tutorials/accessing-your-sites-through-watson-content-hub-apis/#tocstep1 | API URL}.
     * @param {?} logSvc
     * @return {?} the callback function
     */
    function internalFetchTextAjax(apiBase, logSvc) {
        // logger
        /** @type {?} */
        var logger = logSvc.get(FETCH_TEXT_LOGGER);
        // decode the API URL
        /** @type {?} */
        var apiURL = utils.urlFromProvider(apiBase);
        // get the delivery URL
        /** @type {?} */
        var deliveryURL = utils.wchGetResourceUrlFromApiURL(apiURL);
        // check if we are in preview mode
        /** @type {?} */
        var isPreview = utils.wchIsPreviewMode(apiURL);
        // delivery prefix
        /** @type {?} */
        var deliveryPrefix = apiURL.href + "delivery/";
        /**
         * @param {?} aPath
         * @param {?=} aPriority
         * @return {?}
         */
        function fetch(aPath, aPriority) {
            // load using ajax
            /** @type {?} */
            var fetchFct = aPriority === restApi.FETCH_PRIORITY.LOW ? fetchTextLow : fetchTextNormal;
            // check for the delivery part
            /** @type {?} */
            var isDelivery = aPath.indexOf(SLASH) === 0;
            // check if we need to use delivery or API
            /** @type {?} */
            var baseURL = isDelivery ? deliveryURL : apiURL;
            /** @type {?} */
            var path = removeStartingSlash(aPath);
            // prepend with the api URL
            /** @type {?} */
            var url = utils.isAbsoluteURL(aPath) ? aPath : "" + baseURL.href + path;
            // check if we need to use credentials
            /** @type {?} */
            var withCredentials = isPreview || (!isDelivery && url.indexOf(deliveryPrefix) !== 0);
            // log this
            logger.info('fetch text', withCredentials, path);
            // dispatch
            return fetchFct(url, withCredentials);
        }
        // returns the fetch function
        // return safeFetchText(fetch);
        return fetch;
    }
    /**
     * Creates a callback function that loads content via HTTP GET from the API routes.
     *
     * @param {?} apiBase - the {\@link https://developer.ibm.com/customer-engagement/tutorials/accessing-your-sites-through-watson-content-hub-apis/#tocstep1 | API URL}.
     * @param {?=} aLoggerService
     * @return {?} the callback function
     */
    function fetchTextAjax(apiBase, aLoggerService) {
        // resolve the logger
        /** @type {?} */
        var logSvc = utils.boxLoggerService(aLoggerService);
        /** @type {?} */
        var logger = logSvc.get(FETCH_TEXT_LOGGER);
        // construct a cache
        /** @type {?} */
        var cache = utils.createLruCache();
        // attach to the provider
        /** @type {?} */
        var fetchText$ = Promise.resolve(apiBase).then((/**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            return internalFetchTextAjax(url, logSvc);
        }));
        // dispatch
        /** @type {?} */
        var fetch = (/**
         * @param {?} aPath
         * @param {?=} aPriority
         * @return {?}
         */
        function (aPath, aPriority) {
            return utils.rxPipe(rxjs.from(fetchText$), operators.switchMap((/**
             * @param {?} fetchText
             * @return {?}
             */
            function (fetchText) { return fetchText(aPath, aPriority); })));
        });
        /** @type {?} */
        var cachedFetch = (/**
         * @param {?} aPath
         * @param {?=} aPriority
         * @return {?}
         */
        function (aPath, aPriority) { return utils.rxPipe(fetch(aPath, aPriority), utils.opCacheLast); });
        /**
         * Returns a response from the cache. This response will emit the last cached
         * value immeditately but also request a new, fresh value if the observable
         * is not running, already
         *
         * \@param aPath - the path
         * \@param aPriority - optionally the priority
         *
         * \@return the observable with the desired behaviour
         * @type {?}
         */
        var fromCache = (/**
         * @param {?} aPath
         * @param {?=} aPriority
         * @return {?}
         */
        function (aPath, aPriority) {
            return cache(aPath, (/**
             * @param {?} path
             * @return {?}
             */
            function (path) { return cachedFetch(path, aPriority); }), logger);
        });
        // returns the fetch function
        return USE_CACHE ? fromCache : fetch;
    }
    /**
     * @param {?} aItem
     * @return {?}
     */
    function hasRevision(aItem) {
        return isBaseAuthoringItem(aItem) && utils.isString(aItem.rev);
    }
    /**
     * @param {?} logSvc
     * @param {?} url
     * @param {?} aBody
     * @return {?}
     */
    function sendText(logSvc, url, aBody) {
        // check for the method
        /** @type {?} */
        var isDelete = utils.isNil(aBody);
        /** @type {?} */
        var method = isDelete ? 'DELETE' : hasRevision(aBody) ? 'PUT' : 'POST';
        // delete
        /** @type {?} */
        var delete$ = utils.rxPipe(ajax.ajax({ url: url, method: method, withCredentials: true }), operators.mapTo(aBody));
        /** @type {?} */
        var requestDetails = {
            url: url,
            method: method,
            body: utils.jsonStringify(aBody),
            withCredentials: true,
            responseType: 'json',
            headers: {
                'Content-Type': CONTENT_TYPE_HEADER_VALUE_JSON
            }
        };
        // add publish priority header for authoring requests only
        if (url.indexOf('authoring') > 0) {
            requestDetails.headers['x-ibm-dx-publish-priority'] = PUBLISH_PRIORITY_HEADER_VALUE;
        }
        // update
        /** @type {?} */
        var update$ = utils.rxPipe(ajax.ajax(requestDetails), utils.typedPluck('response'), 
        // make sure to decouple the result handling on a new thread
        operators.observeOn(rxjs.asyncScheduler));
        // ok
        return isDelete ? delete$ : update$;
    }
    /**
     * @param {?} object
     * @return {?}
     */
    function isProgressEvent(object) {
        return object instanceof ProgressEvent;
    }
    /**
     * @param {?} object
     * @return {?}
     */
    function isResponseEvent(object) {
        return !isProgressEvent(object);
    }
    /** @type {?} */
    var selectError = utils.pluckPath([
        'currentTarget',
        'response',
        'errors',
        '0'
    ]);
    /**
     * @param {?} aError
     * @return {?}
     */
    function mapError(aError) {
        if (isProgressEvent(aError)) {
            // get the actual error
            /** @type {?} */
            var originalError = selectError(aError);
            if (utils.isNotNil(originalError)) {
                return rxjs.throwError(originalError);
            }
        }
        // just return as is
        return rxjs.throwError(aError);
    }
    /**
     * @template T
     * @param {?} aLogSvc
     * @param {?} aUrl
     * @param {?} aFile
     * @return {?}
     */
    function sendFile(aLogSvc, aUrl, aFile) {
        /** @type {?} */
        var progress$ = new rxjs.Subject();
        /** @type {?} */
        var response$ = utils.rxPipe(ajax.ajax({
            url: aUrl,
            method: 'POST',
            withCredentials: true,
            responseType: 'json',
            headers: {
                'Content-Type': aFile.type
            },
            body: aFile,
            progressSubscriber: new rxjs.Subscriber(progress$)
        }), operators.pluck('response'), operators.observeOn(rxjs.asyncScheduler));
        // progress event with error handling
        /** @type {?} */
        var prg$ = utils.rxPipe(progress$, operators.catchError(mapError));
        // combine
        return rxjs.merge(response$, prg$);
    }
    /**
     * Creates a callback function that writes content to API routes via PUST, POST or delete
     *
     * @param {?} apiBase - the {\@link https://developer.ibm.com/customer-engagement/tutorials/accessing-your-sites-through-watson-content-hub-apis/#tocstep1 | API URL}.
     * @param {?} logSvc - an optional logger service
     * @return {?} the callback function
     */
    function internalWriteJsonAjax(apiBase, logSvc) {
        // logger
        /** @type {?} */
        var logger = logSvc.get('WriteJsonAjax');
        // decode the API URL
        /** @type {?} */
        var apiURL = utils.urlFromProvider(apiBase);
        /**
         * @param {?} aPath
         * @param {?} aBody
         * @return {?}
         */
        function write(aPath, aBody) {
            // check if we need to use delivery or API
            /** @type {?} */
            var path = removeStartingSlash(aPath);
            // prepend with the api URL
            /** @type {?} */
            var url = "" + apiURL.href + path;
            // log this
            logger.info('send request', url);
            if (aBody instanceof File) {
                // request is built based upon explicitly provided details
                return sendFile(logSvc, url, aBody);
            }
            else {
                // request is built based upon implicit conventions)
                return sendText(logSvc, url, aBody);
            }
        }
        // returns the write function
        return write;
    }
    /**
     * Creates a callback function that writes content to API routes via PUST, POST or delete
     *
     * @param {?} apiBase - the {\@link https://developer.ibm.com/customer-engagement/tutorials/accessing-your-sites-through-watson-content-hub-apis/#tocstep1 | API URL}.
     * @param {?=} aLoggerService
     * @return {?} the callback function
     */
    function writeJsonAjax(apiBase, aLoggerService) {
        // resolve the logger
        /** @type {?} */
        var logSvc = utils.boxLoggerService(aLoggerService);
        // attach to the provider
        /** @type {?} */
        var writeText$ = Promise.resolve(apiBase).then((/**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            return internalWriteJsonAjax(url, logSvc);
        }));
        // dispatch
        /**
         * @param {?} aPath
         * @param {?} aBody
         * @return {?}
         */
        function write(aPath, aBody) {
            return utils.rxPipe(rxjs.from(writeText$), operators.switchMap((/**
             * @param {?} writeText
             * @return {?}
             */
            function (writeText) { return writeText(aPath, aBody); })));
        }
        // returns the write function
        return write;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: version.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Version and build number of the package
     * @type {?}
     */
    var VERSION = { version: { major: '9', minor: '0', patch: '10076', branch: 'master' }, build: new Date(1585229427693) };
    /**
     * Module name
     * @type {?}
     */
    var MODULE = '@acoustic-content-sdk/redux-ajax';

    exports.VERSION = VERSION;
    exports.fetchTextAjax = fetchTextAjax;
    exports.writeJsonAjax = writeJsonAjax;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=acoustic-content-sdk-redux-ajax.umd.js.map
